<?php

if (isset($_GET['divisor'])) { $divisor = $_GET['divisor']; }
else { $divisor = 1; }

if (isset($_GET['tracks'])) { $tracks = $_GET['tracks']; }
else { $tracks = 8; }

if (isset($_GET['starttrack'])) { $starttrack = $_GET['starttrack']; }
else { $starttrack = 1; }

if (isset($_GET['file'])) { $filename = $_GET['file']; }
else { $filename = ""; }

if (isset($_GET['secadvance'])) { $secadvance = $_GET['secadvance']; }
else { $secadvance = "2"; }

if (isset($_GET['columnwidth'])) { $columnwidth = $_GET['columnwidth']; }
else { $columnwidth = 80; }

$tracklimit = $tracks + $starttrack;

function later_tag($starttag, $endtag) {

	global $xmlfile;
	global $xmlline;
	
	while (substr_count($xmlline, $starttag) == 0) {
		$xmlline = next($xmlfile);
	}
	
	$trimmed = trim($xmlline);
	$trimmed = ltrim($trimmed, $starttag);
	$trimmed = rtrim($trimmed, $endtag);
	
	return $trimmed;
}

function earlier_tag($starttag, $endtag) {
	
	global $xmlfile;
	global $xmlline;
	
	while (substr_count($xmlline, $starttag) == 0) {
		$xmlline = prev($xmlfile);
	}
	
	$trimmed = trim($xmlline);
	$trimmed = ltrim($trimmed, $starttag);
	$trimmed = rtrim($trimmed, $endtag);
	
	return $trimmed;
}

function manual_tag($starttag, $endtag, $movement) {

	global $xmlfile;
	global $xmlline;
	
	if ($movement > 0) {
		for ($i = 0; $i < $movement; $i++  ) {
			$xmlline = next($xmlfile);
		}
	}

	if ($movement < 0) {
		for ($i = 0; $i > $movement; $i--  ) {
			$xmlline = prev($xmlfile);
		}
	}

	$trimmed = trim($xmlline);
	$trimmed = ltrim($trimmed, $starttag);
	$trimmed = rtrim($trimmed, $endtag);
	
	return $trimmed;
}


if (file_exists($filename)) {
	
	$xmlfile = file($filename);
	$xmlfilelength = count($xmlfile);
	
	$trackcount = 1;
	$xmllinenum = 0;
	$clipsout = 0;
	$clipend = 0;
	$totaltracks=0;
	
	reset($xmlfile);
	$xmlline = current($xmlfile);
	
/*	while (substr_count($xmlline, "</xmeml>") == 0 && $xmlline != false) { //loop through to end to get number of tracks
		if(substr_count($xmlline, "<format>") != 0) {
			$xmlline = prev($xmlfile);
			if(substr_count($xmlline, "<audio>") != 0) { $audiosection = true ; }
		}
		
		if (substr_count($xmlline, "<track>") != 0 && $audiosection == true) {  //if it's an audio track
			$totaltracks++;		
		}
		$xmlline = next($xmlfile);
	}
	
	reset($xmlfile); //after running through the whole file, go back to the start
	$xmlline = current($xmlfile); */
	
	$sequencename = later_tag('<sequence id="', '">');
	
	$dir = getcwd();
	
	if (is_dir($dir)) { //reads all files in current directory
		if ($dh = opendir($dir)) {
			while (($file = readdir($dh)) !== false) {
				$files[] = $file;
			}
			closedir($dh);		
		}
	}
	
	sort($files);	

	?>
	
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	
	<head>
		<title><?php echo ('Cue Sheet '.$sequencename.' Track '.$starttrack.'-'.($tracklimit-1)); ?></title>
		<link href="cuesheet.css" type="text/css" rel="stylesheet" media="all" />
		<link rel="stylesheet" type="text/css" media="print" href="print.css" />
	</head>
	
	<body bgcolor="#ffffff">

	<div class="options">
	<form name="headerform" action="index.php" method="get">
	File <select name="file">
	<?php 
	foreach($files as $currentfile) {
		if (substr_count($currentfile, '.xml') != 0) { //creates option for each XML file in directory
			echo ('<option value="'.$currentfile.'"');
			
			if ($currentfile == $filename) { echo (' selected '); }
			
			echo ('>'.$currentfile.'</option>');
		}
	}
	?>
	</select>
	Start Track <!-- <select name="starttrack">
	<?php
	 for ($i = 1; $i <= $totaltracks; $i++) {
		echo ('option value="'.$i.'"');
		if ($i == $starttrack) { echo (' selected '); }
		echo ('>'.$i.'</option>');

	}
	?>
	</select> -->
	<input name="starttrack" value="<?php echo($starttrack); ?>" size="2"> 
	# of tracks <input name="tracks" value="<?php echo($tracks); ?>" size="2">
	Timecode every <input name="secadvance" value="<?php echo($secadvance); ?>" size="2">second<?php if ($secadvance != 1) {echo 's';} ?>
	1 pixel = <input name="divisor" value="<?php echo($divisor); ?>" size="2">frame<?php if ($divisor != 1) {echo 's';} ?>
	Width <input name="columnwidth" value="<?php echo($columnwidth); ?>" size="2">
	<INPUT type="submit" value="Send">
	</form>
	</div>
	
	<table width="<?php echo(100 + ($tracks * ($columnwidth + 14))); ?>px">
	<thead>
	<tr>
	<td class="header" style="width:80px">Timecode</td>
	<?php
	
	
	for ($i = $starttrack; $i < $tracklimit; $i++) {
		echo '<td class="header" style="width:'.$columnwidth.'px">Track '.$i.'</td>';
	}
	
	?>
	</tr>
	</thead>
	<tbody>
	<tr>
	<?php


	$totallength = later_tag('<duration>', '</duration>');
	$framerate = later_tag('<timebase>', '</timebase>');
	$starttimecode = later_tag('<string>', '</string>');

	$maxsec = ($totallength / $framerate);
	$timeincrement = ($secadvance * $framerate / $divisor);
	$seconds = substr($starttimecode, 6, 2);
	$minutes = substr($starttimecode, 3, 2);
	$hours = substr($starttimecode, 0, 2);
	$totalseconds = 0;
	
	echo '<td>'."\n"; //starts the Timecode column
	
	while ($totalseconds <= $maxsec) {
		echo '<div class="timecode"  style="height:'.$timeincrement.'px;">'.sprintf("%02d", $hours).':'.sprintf("%02d", $minutes).':'.sprintf("%02d", $seconds).':00</div>'."\n";
		
		$seconds = ($seconds + $secadvance);

		if ($seconds >= 60) {
			$minutes++;
			$seconds = $seconds - 60;
		}
		
		if ($minutes >= 60) {
			$hours++;
			$minutes = $minutes -60;
		}
		
		$totalseconds = ($totalseconds + $secadvance);
	}
	
	echo '</td>'; //end Timecode column
	
	while (substr_count($xmlline, "</xmeml>") == 0 && $xmlline != false) { //loops through XML file until the end
		
		if(substr_count($xmlline, "<format>") != 0) {
			
			$xmlline = prev($xmlfile);
			
			if(substr_count($xmlline, "<audio>") != 0) {
				
				while ($trackcount < $tracklimit && substr_count($xmlline, "</xmeml>") == 0) { // loop until we hit the track limit or EOF

					if (substr_count($xmlline, "<track>") != 0 && $trackcount >= $starttrack ) {  //if it's a track
				
						echo '<td>'."\n";
				
						while (substr_count($xmlline, "</track>") == 0) { //loop until the track ends				
		
							if (substr_count($xmlline, '<clipitem id="') != 0) { //if this is a clip ID
							
								$clipname = later_tag('<clipitem id="', '">');
								$clipstart = later_tag('<start>','</start>'); //get the start point
								$clipend = later_tag('<end>', '</end>'); //get the end point
								$clipenabled = manual_tag('<enabled>', '</enabled>', 2); //determine if the clip is enabled
								
								if ($clipenabled !== "FALSE") {
							
									if ($clipstart == "-1") { //clip uses the previous transition to determine start value
										while (substr_count($xmlline, "</transitionitem>") == 0) { $xmlline = prev($xmlfile); } //move back to find the transition which has the actual start value
											
										$transitionalignment = earlier_tag('<alignment>', '</alignment>');				
										$transitionend = earlier_tag('<end>', '</end>');
										$transitionstart = earlier_tag('<start>', '</start>');
										$transitionduration = ($transitionend - $transitionstart);
										
										if ($transitionalignment == "center") {
											$clipstart = ($transitionstart + ($transitionduration/2));
										}
										
										else { $clipstart = $transitionstart; }
															
										while (substr_count($xmlline, "<clipitem ") == 0) { $xmlline = next($xmlfile); } //move down to the current clip										
									}
							
	
							
									if ($clipend == "-1") { //clip uses the next transition to determine end value
										while (substr_count($xmlline, "<transitionitem>") == 0) { $xmlline = next($xmlfile); } //move forward to find the transition which has the actual start value
											
										$transitionstart = later_tag('<start>', '</start>');
										$transitionend = later_tag('<end>', '</end>');
										$transitionalignment = later_tag('<alignment>', '</alignment>');	
										$transitionduration = ($transitionend - $transitionstart);
						
										if ($transitionalignment == "center") {
											$clipend = ($transitionstart - ($transitionduration/2));
										}
										
										else { $clipend = ($transitionend); }
										
										$clipduration = (($clipend - $clipstart)/$divisor);
				
									}
							
									$clipduration = (($clipend - $clipstart)/$divisor);
									
									if ($clipduration < 20) { 
										$clipcharacters = floor($columnwidth * 0.2);
										$clipname = substr($clipname, 0, $clipcharacters); //truncates clipname to fit on one line if it's less than 20 frames long
									}
									
									$cliptopabsolute = (($clipstart / $divisor) + 73);
									$clipleftabsolute = (113 + (($columnwidth + 14) * ($trackcount - $starttrack )));
									echo '<div style="height:'.$clipduration.'px; width:'.$columnwidth.'px; position:absolute; top:'.$cliptopabsolute.'px; left:'.$clipleftabsolute.'px" class="clip">'.$clipname.'</div>'."\n";  //writes clip DIV
								}
							}
													
							$xmlline = next($xmlfile); //next line within the track
						}

					}
					
					if (substr_count($xmlline, "</track>") != 0 && $trackcount >= $starttrack) {
						echo '</td>	'."\n";	
						$trackcount++;
						$clipend = 0;
					}
					
					if (substr_count($xmlline, "</track>") != 0 && $trackcount < $starttrack) {
						$trackcount++;	
					}
						
					$xmlline = next($xmlfile); //next line to find track start or end
				}				
			}
			
			else { $xmlline = next($xmlfile); }
		}

		if ($trackcount >= $tracklimit) { break; }		
		$xmlline = next($xmlfile);
	}

	?>
	</td>
	</tr>
	</tbody>
	</table>
		</body>
	
	</html>
	
	<?php
}

else { echo 'No input file'; }